//////////////////////////////////////////////////////////////////////////////
//
//  opu_quick_fill_descr_attr.cpp
//
//  Description:
//      Contains Unigraphics entry points for the application.
//
//////////////////////////////////////////////////////////////////////////////

#define _CRT_SECURE_NO_DEPRECATE 1

//  Include files
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h>

#include <uf_setup.h>
#include <uf_cam.h>
#include <uf_oper.h>
#include <uf_ncgroup.h>
#include <uf_obj.h>
#include <uf_part.h>
#include <uf_ui_ont.h>
#include <uf_param.h>
#include <uf_ugopenint.h>
#include <uf_param_indices.h>
#include <uf_attr.h>

/*
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
# include <strstream>
  using std::ostrstream;
  using std::endl;
  using std::ends;
#else
# include <strstream.h>
#endif
#include <iostream.h>
*/

#include "opu_quick_fill_descr_attr.h"


/* The following definition defines the number of callback entries */
/* in the callback structure:                                      */
/* UF_STYLER_callback_info_t Z_cbs */
#define Z_CB_COUNT ( 10 + 1 ) /* Add 1 for the terminator */

/*--------------------------------------------------------------------------
The following structure defines the callback entries used by the
styler file.  This structure MUST be passed into the user function,
UF_STYLER_create_dialog along with Z_CB_COUNT.
--------------------------------------------------------------------------*/
static UF_STYLER_callback_info_t Z_cbs[Z_CB_COUNT] =
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, Z_construct_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, Z_ok_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB        , 0, Z_apply_cb},
 {Z_ACTION_ABOUT        , UF_STYLER_ACTIVATE_CB     , 0, Z_action_0_act_cb},
 {Z_BLO_FILE            , UF_STYLER_ACTIVATE_CB     , 0, Z_blo_file_act_cb},
 {Z_LIST_DESCR          , UF_STYLER_ACTIVATE_CB     , 0, Z_select_list_cb},
 {Z_LIST_DESCR          , UF_STYLER_DOUBLE_CLICK_CB , 0, Z_select_dbl_cb},
 {Z_WIDE_S_DESC         , UF_STYLER_ACTIVATE_CB     , 0, Z_desc_cb},
 {Z_ACTION_ADD_TEMPLATE , UF_STYLER_ACTIVATE_CB     , 0, Z_action_add_act_cb},
 {Z_ACTION_DEL          , UF_STYLER_ACTIVATE_CB     , 0, Z_action_del_act_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};



/*--------------------------------------------------------------------------
UF_MB_styler_actions_t contains 4 fields.  These are defined as follows:

Field 1 : the name of your dialog that you wish to display.
Field 2 : any client data you wish to pass to your callbacks.
Field 3 : your callback structure.
Field 4 : flag to inform menubar of your dialog location.  This flag MUST
          match the resource set in your dialog!  Do NOT ASSUME that changing
          this field will update the location of your dialog.  Please use the
          UIStyler to indicate the position of your dialog.
--------------------------------------------------------------------------*/
static UF_MB_styler_actions_t actions[] = {
    { "opu_quick_fill_descr_attr.dlg",  NULL,   Z_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};



char *description="DESC1";

#define INIT_NUM 50
char INIT_names[INIT_NUM][101] ;
int INIT_count = 0;

int ufusr_main( void );
int _action_0_act_cb ( void );
int _construct_cb ( int dialog_id );
int _set_cb ( int dialog_id );
//int _option_corner ( int dialog_id );
//int _toggle_sp ( int dialog_id );
int _file_load_cb ( int dialog_id ) ;
int _file_save_cb ( int dialog_id ) ;
int _clear_cb     ( int dialog_id ) ;
int _blo_but_act_cb ( int dialog_id, UF_STYLER_item_value_type_p_t callback_data);

int dialog_id_read_prt_cb = 0;
int _add_str(char *add);
static logical cycleGenerateCb( tag_t   tag, void   *data ) ;
int _read_prt_cb ( int dialog_id );

int _select_dbl_cb ( int dialog_id );
int _action_add_act_cb ( int dialog_id );
int _action_del_act_cb ( int dialog_id );


//----------------------------------------------------------------------------
//  Activation Methods
//----------------------------------------------------------------------------

//  Explicit Activation
//      This entry point is used to activate the application explicitly, as in
//      "File->Execute UG/Open->User Function..."
extern "C" DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    /* Initialize the API environment */
    int errorCode = UF_initialize();

    if ( 0 == errorCode )
    {
        /* TODO: Add your application code here */
        ufusr_main( ) ;

        /* Terminate the API environment */
        errorCode = UF_terminate();
    }

    /* Print out any error messages */
    *returnCode=0;
}

//----------------------------------------------------------------------------
//  Utilities
//----------------------------------------------------------------------------

// Unload Handler
//     This function specifies when to unload your application from Unigraphics.
//     If your application registers a callback (from a MenuScript item or a
//     User Defined Object for example), this function MUST return
//     "UF_UNLOAD_UG_TERMINATE".
extern int ufusr_ask_unload (void)
{
     /* unload immediately after application exits*/
     return ( UF_UNLOAD_IMMEDIATELY );

     /*via the unload selection dialog... */
     /*return ( UF_UNLOAD_SEL_DIALOG );   */
     /*when UG terminates...              */
     /*return ( UF_UNLOAD_UG_TERMINATE ); */
}


/*--------------------------------------------------------------------------
You have the option of coding the cleanup routine to perform any housekeeping
chores that may need to be performed.  If you code the cleanup routine, it is
automatically called by Unigraphics.
--------------------------------------------------------------------------*/
extern void ufusr_cleanup (void)
{
    return;
}




/*********************************************
*********************************************/
int ufusr_main( )
{
  int errorCode;
  int response ;
  int module_id;

  UF_ask_application_module(&module_id);
  if (UF_APP_CAM!=module_id) {
    uc1601(" DLL -    CAM \n, 2007.\nDLL terminated...",1);
    return(0) ;
  }

  if (NULL_TAG==UF_PART_ask_display_part()) {
      uc1601("Cam-  .....\n  .",1);
      return (0);
  }

   if ( ( errorCode = UF_STYLER_create_dialog (
            actions->styler_file,
           Z_cbs,      /* Callbacks from dialog */
           Z_CB_COUNT, /* number of callbacks*/
            NULL,        /* This is your client data */
            &response ) ) != 0 )
    {
          char fail_message[133];

          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(errorCode, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message );

          uc1601("   \n - - ",1);
          return (-1);
    }

  return(0);
}

int _action_0_act_cb ( void )
{
  int response ;
  char *mes[]={"    ",
  	"  ",
  	" 'DESCR'  ",
  	" .",
  	" (2007 ).",
  	NULL};
  UF_UI_message_buttons_t buttons1 = { TRUE, FALSE, FALSE, "Ok", NULL, NULL, 1, 2, 3 };

  response=0;
  UF_UI_message_dialog("About program...", UF_UI_MESSAGE_QUESTION, mes, 5, TRUE, &buttons1, &response);

	return 0 ;
}

int _construct_cb ( int dialog_id )
{
 UF_STYLER_item_value_type_t data1  ;
 int jj;
 int user_count ;       char **user_names ;

 UF_UI_ONT_switch_view( UF_UI_ONT_order ) ;

 data1.item_id=Z_LIST_DESCR;
 data1.item_attr=UF_STYLER_SUBITEM_VALUES;
 UF_STYLER_ask_value(dialog_id,&data1);
 user_names=data1.value.strings;
 user_count=data1.count;

 INIT_count=user_count;

 for( jj = 0; jj < user_count; jj++ ) {
    if (jj>=INIT_NUM) break ;
    INIT_names[jj][0]='\0';sprintf(INIT_names[jj],"%s",user_names[jj]);
  }

 UF_free_string_array( user_count, (char **)user_names );

 UF_STYLER_free_value (&data1) ;

 return (0);
}

int _set_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;

  tag_t  prg = NULL_TAG;
  tag_t *tags = NULL ;
  int   obj_count = 0;
  int i, count = 0 ;
  char str[133];
  UF_ATTR_value_t value;
  char     title[UF_ATTR_MAX_TITLE_LEN+1]="";
  char     string_value[UF_ATTR_MAX_STRING_LEN+1]="";

  //     -
  UF_UI_ONT_ask_selected_nodes(&obj_count, &tags) ;
  if (obj_count<=0) {
      uc1601("There are no operations/programs selected",1);
      return(0);
  }

  UF_UI_toggle_stoplight(1);

  data.item_attr=UF_STYLER_VALUE;
  data.item_id=Z_WIDE_S_DESC;
  UF_STYLER_ask_value(dialog_id,&data);
  string_value[0]='\0'; sprintf(string_value,"%s",data.value.string);

  UF_STYLER_free_value (&data) ;

  title[0]='\0'; sprintf(title,"%s",description);

  for(i=0,count=0;i<obj_count;i++)
  {
    prg = tags[i]; //  

    /*  Assign a string attribute to the object */
        value.type = UF_ATTR_string;
        value.value.string = string_value;
        UF_ATTR_assign(prg, title , value);

    count++;
  }
  UF_free(tags);

//  UF_UI_ONT_refresh();
//  UF_DISP_refresh ();

  UF_UI_toggle_stoplight(0);

  str[0]='\0'; sprintf(str,"ADD PARAM (%d)(%.10s)=%.100s",count,title,string_value);
  UF_UI_set_status (str);

  return (0);
}


int _file_load_cb ( int dialog_id )
{
  char prompt[]="Specify LOAD file name";
  char * title="LOAD Specification";
  char filter[UF_CFI_MAX_PATH_NAME_SIZE] ;
  char *default_name="";
  char file_name[UF_CFI_MAX_PATH_NAME_SIZE];
  int  response;

  sprintf(filter, "*.txt");

  UF_UI_create_filebox (prompt,title,filter, default_name, file_name, &response ) ;
  if ( response != UF_UI_OK ) { return (-1); }

  UF_CFI_ask_file_exist (file_name,&response);
  if (response!=0) {
  	uc1601("File not exists !!!\n break ..",1);
  	return (-2);
  }

  char *mes[]={"","","",NULL};
  UF_UI_message_buttons_t buttons3 = { TRUE, TRUE, TRUE, "Rewrite", "Append", "Cancel", 1, 2, 3 };
  response=0;
  UF_UI_message_dialog("Merge List with file..?", UF_UI_MESSAGE_QUESTION, mes, 1, TRUE, &buttons3, &response);
  if (response==3) { return (0) ; }

  if (response==1) { _clear_cb(dialog_id) ; }

 UF_STYLER_item_value_type_t data1  ;

 int i , l , jj ;
 FILE *rf ;
 char str[101];
 rf=fopen(file_name,"r");
 if (NULL==rf) {
  	uc1601("Cannot OPEN or Read File !!!\n break ..",1);
  	return (-3);
 }

 data1.item_id=Z_LIST_DESCR;

 data1.item_attr=UF_STYLER_SUBITEM_VALUES;
 UF_STYLER_ask_value(dialog_id,&data1);
 jj=data1.count;
 if (jj<=0) jj=0; else jj++; // next position

 data1.item_attr=UF_STYLER_LIST_INSERT;
 data1.indicator=UF_STYLER_STRING_VALUE;

 str[0]='\0'; fgets(str,100,rf);
 while(!feof(rf))
 {
  l=strlen(str);
  for(i=0;i<l;i++) {
    if (str[i]=='\n') { str[i]='\0'; break ; }
  }
  data1.subitem_index=jj;
  data1.value.string=str;
  UF_STYLER_set_value(dialog_id,&data1);
  str[0]='\0'; fgets(str,100,rf);
  jj++;
 } // end while

 fclose(rf);

 UF_STYLER_free_value (&data1) ;

  return (0);
}


int _file_save_cb ( int dialog_id )
{
  char prompt[]="Specify Output file name";
  char * title=" Output Specification";
  char filter[UF_CFI_MAX_PATH_NAME_SIZE] ;
  char *default_name="1.txt";
  char file_name[UF_CFI_MAX_PATH_NAME_SIZE];
  int  response;

  sprintf(filter, "*.txt");

  UF_UI_create_filebox (prompt,title,filter, default_name, file_name, &response ) ;
  if ( response != UF_UI_OK ) { return (-1); }

  char mode[3]="w";
  char *mes[]={"FILE - exists ?","","",NULL};
  UF_UI_message_buttons_t buttons3 = { TRUE, TRUE, TRUE, "Rewrite", "Append", "Cancel", 1, 2, 3 };

  UF_CFI_ask_file_exist (file_name,&response);
  if (response==0) {
    response=0;
    UF_UI_message_dialog("Merge List with file..?", UF_UI_MESSAGE_QUESTION, mes, 1, TRUE, &buttons3, &response);
    if (response==3) { return (0) ; }

    if (response==1) { sprintf(mode,"%s","a"); }
  }

 UF_STYLER_item_value_type_t data1  ;
 int user_count ;       char **user_names ;
 int jj ;
 FILE *rf ;
 char str[101];
 rf=fopen(file_name,mode);
 if (NULL==rf) {
  	uc1601("Cannot OPEN or Read File for WRITE|APPEND !!!\n break ..",1);
  	return (-3);
 }

 data1.item_id=Z_LIST_DESCR;
 data1.item_attr=UF_STYLER_SUBITEM_VALUES;
 UF_STYLER_ask_value(dialog_id,&data1);
 user_names=data1.value.strings;
 user_count=data1.count;

 for( jj = 0; jj < user_count; jj++ ) {
    str[0]='\0';
    sprintf(str,"%s\n",user_names[jj]);
    fputs(str,rf);
 }

 UF_free_string_array( user_count, (char **)user_names );

 fclose(rf);

 UF_STYLER_free_value (&data1) ;

  return (0);
}


int _clear_cb(int dialog_id)
{
  UF_STYLER_item_value_type_t data1  ;

  data1.item_id=Z_LIST_DESCR;
  data1.item_attr=UF_STYLER_LIST_DELETE;
  data1.subitem_index=UF_STYLER_NO_SUB_INDEX;
  UF_STYLER_set_value(dialog_id,&data1);

  UF_STYLER_free_value (&data1) ;

  return (0);
}

/* */
/*----------------------------------------------------------------------------*/
static logical cycleGenerateCb( tag_t   tag, void   *data )
{
  logical  is_group ;
  int      ecode;

  ecode = UF_NCGROUP_is_group( tag, &is_group );
  //if( is_group != TRUE ) return( FALSE );

  int indx = 0, n;
  char title[UF_ATTR_MAX_TITLE_LEN+1];
  UF_ATTR_value_t  att;

  UF_ATTR_count_attributes(tag, UF_ATTR_any, &n);
  while (!UF_ATTR_cycle(tag, &indx, UF_ATTR_any, title, &att) && indx)
  {
     switch ( att.type )
     {
         case UF_ATTR_integer:
             printf("%s = %d (INTEGER)\n", title, att.value.integer);
         break;

         case UF_ATTR_real:
             printf("%s = %f (FLOATING POINT)\n", title,att.value.real);
         break;

         case UF_ATTR_time:
         break;

         case UF_ATTR_null:
             printf("%s = (NULL)\n", title);
         break;

         case UF_ATTR_string:
             printf("%s = %s (STRING)\n", title, att.value.string);
             if (0==strcmp(title,description)) _add_str(att.value.string);
             //UF_free(att.value.string);
         break;

         case UF_ATTR_reference:
             printf("%s = %s (REFERENCE)\n", title,att.value.reference);
             //UF_free(att.value.reference);
         break;

         default:
         break;
     }

  }

   return( TRUE );
}

int _add_str(char *add)
{
  UF_STYLER_item_value_type_t data  ;

  data.item_id=Z_LIST_DESCR;
  data.item_attr=UF_STYLER_LIST_INSERT;
  data.indicator=UF_STYLER_STRING_VALUE;
  data.subitem_index=0;
  data.value.string=add;
  UF_STYLER_set_value(dialog_id_read_prt_cb,&data);
  data.item_attr=UF_STYLER_LIST_SHOW;
  data.item_attr=UF_STYLER_VALUE;
  data.subitem_index=0;
  UF_STYLER_set_value(dialog_id_read_prt_cb,&data);

  UF_STYLER_free_value (&data) ;

	return (0);
}


int _read_prt_cb(int dialog_id)
{
  tag_t setup_tag, group ;
  int ecode ;

  int response ;
  char *mes[]={"","","",NULL};
  UF_UI_message_buttons_t buttons3 = { TRUE, TRUE, TRUE, "Rewrite", "Append", "Cancel", 1, 2, 3 };
  response=0;
  UF_UI_message_dialog("Merge List with PRT..?", UF_UI_MESSAGE_QUESTION, mes, 3, TRUE, &buttons3, &response);
  if (response==3) { return (0) ; }

  if (response==1) { _clear_cb(dialog_id) ; }

  ecode = UF_SETUP_ask_setup(&setup_tag);
  if( ecode != 0 ) { ; }

  ecode = UF_SETUP_ask_program_root(setup_tag,&group);
  if( ecode != 0 ) { ; }

  dialog_id_read_prt_cb = dialog_id ;
  ecode = UF_NCGROUP_cycle_members( group, cycleGenerateCb,NULL );
  if( ecode != 0 ) { ; }

  return (0);
}

int _blo_but_act_cb ( int dialog_id, UF_STYLER_item_value_type_p_t callback_data)
{
    UF_STYLER_item_value_type_t data1  ;
    int ind ;

    ind=callback_data->value.integer;

    if (ind==0) //
    {
      _file_load_cb( dialog_id);
    }
    if (ind==1) //
    {
      _file_save_cb( dialog_id);
    }
    if (ind==2) //clear
    {
      _clear_cb( dialog_id) ;
    }
    if (ind==3) //init
    {
      data1.item_id=Z_LIST_DESCR;
      data1.item_attr=UF_STYLER_LIST_INSERT;
      data1.indicator=UF_STYLER_STRING_VALUE;

      if (INIT_count>0) {
       for(int jj = 0; jj < INIT_count; jj++ ) {
        data1.subitem_index=jj;
        data1.value.string=INIT_names[jj];
        UF_STYLER_set_value(dialog_id,&data1);
       }
      }

      UF_STYLER_free_value (&data1) ;
    }
    if (ind==4) //read from prt
    {
      _read_prt_cb( dialog_id);
    }

    return (0);
}

int _select_dbl_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;
  char str0[101], str1[101], str2[251];
  int l = 0 ;

  data.item_attr=UF_STYLER_VALUE;

  data.item_id=Z_LIST_DESCR;
  data.indicator=UF_STYLER_STRING_VALUE; // UF_STYLER_INTEGER_VALUE
  UF_STYLER_ask_value(dialog_id,&data);
  //jj=data.subitem_index;
  str0[0]='\0'; sprintf(str0,"%s",data.value.string);

  data.item_id=Z_WIDE_S_DESC;
  UF_STYLER_ask_value(dialog_id,&data);
  str1[0]='\0'; sprintf(str1,"%s",data.value.string);

  str2[0]='\0'; sprintf(str2,"%.100s %.100s",str1,str0);
  l=strlen(str2);
  if (l>=100) str2[99]='\0';
  data.item_id=Z_WIDE_S_DESC;
  data.value.string=str2;
  UF_STYLER_set_value(dialog_id,&data);

  UF_STYLER_free_value (&data) ;
  return (0);
}

int _action_add_act_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;
  char str1[101];

  data.item_attr=UF_STYLER_VALUE;
  data.item_id=Z_WIDE_S_DESC;
  UF_STYLER_ask_value(dialog_id,&data);
  str1[0]='\0'; sprintf(str1,"%.100s",data.value.string);

  data.item_id=Z_LIST_DESCR;
  data.item_attr=UF_STYLER_LIST_INSERT;
  data.indicator=UF_STYLER_STRING_VALUE;
  data.subitem_index=0;
  data.value.string=str1;
  UF_STYLER_set_value(dialog_id,&data);
  data.item_attr=UF_STYLER_LIST_SHOW;
  data.item_attr=UF_STYLER_VALUE;
  data.subitem_index=0;
  UF_STYLER_set_value(dialog_id,&data);

  UF_STYLER_free_value (&data) ;
  return (0);
}

int _action_del_act_cb ( int dialog_id )
{
  UF_STYLER_item_value_type_t data  ;

  data.item_attr=UF_STYLER_VALUE;
  data.item_id=Z_WIDE_S_DESC;
  data.value.string="";
  UF_STYLER_set_value(dialog_id,&data);

  UF_STYLER_free_value (&data) ;
  return (0);
}


/*-------------------------------------------------------------------------*/
/*---------------------- UIStyler Callback Functions ----------------------*/
/*-------------------------------------------------------------------------*/

/* -------------------------------------------------------------------------
 * Callback Name: Z_construct_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_construct_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _construct_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must continue dialog construction.*/

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_ok_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_ok_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
      _set_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, terminate dialog             */
    /* It is STRONGLY recommended that you exit your       */
    /* callback with UF_UI_CB_EXIT_DIALOG in a ok callback.*/
    /* return ( UF_UI_CB_EXIT_DIALOG );                    */
    return (UF_UI_CB_EXIT_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_apply_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_apply_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _set_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog                 */
    /* A return value of UF_UI_CB_EXIT_DIALOG will not be accepted    */
    /* for this callback type.  You must respond to your apply button.*/
    return (UF_UI_CB_CONTINUE_DIALOG);

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_action_0_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_action_0_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _action_0_act_cb ( ) ;

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_blo_file_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_blo_file_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
      _blo_but_act_cb (dialog_id,callback_data);

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_select_list_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_select_list_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_select_dbl_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_select_dbl_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _select_dbl_cb ( dialog_id ) ;

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.  */
    /* return ( UF_UI_CB_EXIT_DIALOG );             */

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_desc_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_desc_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}


/* -------------------------------------------------------------------------
 * Callback Name: Z_action_add_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_action_add_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _action_add_act_cb ( dialog_id );

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}

/* -------------------------------------------------------------------------
 * Callback Name: Z_action_del_act_cb
 * This is a callback function associated with an action taken from a
 * UIStyler object.
 *
 * Input: dialog_id   -   The dialog id indicate which dialog this callback
 *                        is associated with.  The dialog id is a dynamic,
 *                        unique id and should not be stored.  It is
 *                        strictly for the use in the NX Open API:
 *                               UF_STYLER_ask_value(s)
 *                               UF_STYLER_set_value
 *        client_data -   Client data is user defined data associated
 *                        with your dialog.  Client data may be bound
 *                        to your dialog with UF_MB_add_styler_actions
 *                        or UF_STYLER_create_dialog.
 *        callback_data - This structure pointer contains information
 *                        specific to the UIStyler Object type that
 *                        invoked this callback and the callback type.
 * -----------------------------------------------------------------------*/
int Z_action_del_act_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
     /* Make sure User Function is available. */
     if ( UF_initialize() != 0)
          return ( UF_UI_CB_CONTINUE_DIALOG );

     /* ---- Enter your callback code here ----- */
     _action_del_act_cb ( dialog_id );

     UF_terminate ();

    /* Callback acknowledged, do not terminate dialog */
    return (UF_UI_CB_CONTINUE_DIALOG);

    /* or Callback acknowledged, terminate dialog.    */
    /* return ( UF_UI_CB_EXIT_DIALOG );               */

}
